<app-page-title [heading]="heading" [subheading]="subheading" [icon]="icon">
  <button class="btn btn-success" (click)="buscar()" [disabled]="!ngForm.valid">
    <i class="fas fa-search mr-2"></i>Buscar
  </button>
  <button class="btn btn-secondary ml-1" (click)="openModal(modal, 'bgl')">
    <i class="fas fa-search mr-2"></i>Buscar Global
  </button>

</app-page-title>

<div class="card">
  <div class="card-body">

    <form [formGroup]="ngForm">

      <div class="row">
        <div class="col col-sm-4 col-md-4 col-lg-4 col-xl-4">
          <label># Brazalete</label>
          <input type="number" class="form-control" formControlName="iInt1">
        </div>
        <div class="col col-sm-4 col-md-4 col-lg-4 col-xl-4">
          <label>Cuarto</label>
          <div class="input-group">
            <input type="text" class="form-control" maxlength="6" formControlName="cChr1">
            <div class="input-group-append">
              <button class="btn btn-outline-secondary" type="button" (click)="openModal(modal, 'crt')">
                <i class="fas fa-search"></i>
              </button>
            </div>
          </div>
        </div>
        <div class="col col-sm-4 col-md-4 col-lg-4 col-xl-4">
          <label>Tipo</label>
          <div class="input-group">
            <input type="text" class="form-control" maxlength="2" formControlName="cChr2">
            <div class="input-group-append">
              <button class="btn btn-outline-secondary" type="button" (click)="openModal(modal, 'tbn')">
                <i class="fas fa-search"></i>
              </button>
            </div>
          </div>
        </div>
      </div>

    </form>

    <div *ngIf="!loading">

      <kendo-grid [kendoGridBinding]="dataGrid"
                  [resizable]="true"
                  [navigable]="true"
                  [pageSize]="pageSize"
                  [sortable]="true"
                  filterable="menu"
                  [skip]="skip"
                  [pageable]="{buttonCount: 5, pageSizes: [10, 25, 50]}"
                  [height]="410">
        <ng-template kendoGridToolbarTemplate>
          <div class="row">
            <div class="col-sm-10 col-md-10 col-lg-10 col-xl-10"></div>
            <div class="col-sm-2 col-md-2 col-lg-2 col-xl-2">
              <button class="btn btn-block btn-success" (click)="export(base64)" [disabled]="base64 == ''">
                <i class="fas fa-file-excel mr-2"></i>Excel
              </button>
            </div>
          </div>
        </ng-template>
        <ng-container *ngIf="dataGrid.length !== 0">

          <kendo-grid-column field="Tipo" title="Tipo" width="150">
            <ng-template kendoGridFilterMenuTemplate
                         let-column="column"
                         let-filter="filter"
                         let-filterService="filterService">
              <multicheck-filter [isPrimitive]="true"
                                 [field]="column.field"
                                 [filterService]="filterService"
                                 [currentFilter]="filter"
                                 [data]="distinctPrimitive(column.field)">
              </multicheck-filter>
            </ng-template>
          </kendo-grid-column>
          <kendo-grid-column field="Brazalete" title="Banda" width="150">
            <ng-template kendoGridFilterMenuTemplate
                         let-column="column"
                         let-filter="filter"
                         let-filterService="filterService">
              <multicheck-filter [isPrimitive]="true"
                                 [field]="column.field"
                                 [filterService]="filterService"
                                 [currentFilter]="filter"
                                 [data]="distinctPrimitive(column.field)">
              </multicheck-filter>
            </ng-template>
          </kendo-grid-column>

          <kendo-grid-column field="FechaVigencia" title="Fecha de Vigencia" width="150">
            <ng-template kendoGridFilterMenuTemplate
                         let-filter let-column="column"
                         let-filterService="filterService">
              <date-range-filter [field]="column.field"
                                 [filter]="filter"
                                 [filterService]="filterService">
              </date-range-filter>
            </ng-template>
          </kendo-grid-column>

          <kendo-grid-column field="NoCuarto" title="# Cuarto" width="150">
            <ng-template kendoGridFilterMenuTemplate
                         let-column="column"
                         let-filter="filter"
                         let-filterService="filterService">
              <multicheck-filter [isPrimitive]="true"
                                 [field]="column.field"
                                 [filterService]="filterService"
                                 [currentFilter]="filter"
                                 [data]="distinctPrimitive(column.field)">
              </multicheck-filter>
            </ng-template>
          </kendo-grid-column>
          <kendo-grid-column field="NoFolio" title="# Folio" width="150">
            <ng-template kendoGridFilterMenuTemplate
                         let-column="column"
                         let-filter="filter"
                         let-filterService="filterService">
              <multicheck-filter [isPrimitive]="true"
                                 [field]="column.field"
                                 [filterService]="filterService"
                                 [currentFilter]="filter"
                                 [data]="distinctPrimitive(column.field)">
              </multicheck-filter>
            </ng-template>
          </kendo-grid-column>
          <kendo-grid-column field="Nombre" title="Nombre" width="150">
            <ng-template kendoGridFilterMenuTemplate
                         let-column="column"
                         let-filter="filter"
                         let-filterService="filterService">
              <multicheck-filter [isPrimitive]="true"
                                 [field]="column.field"
                                 [filterService]="filterService"
                                 [currentFilter]="filter"
                                 [data]="distinctPrimitive(column.field)">
              </multicheck-filter>
            </ng-template>
          </kendo-grid-column>
          <kendo-grid-column field="Ope" title="Ope." width="150">
            <ng-template kendoGridFilterMenuTemplate
                         let-column="column"
                         let-filter="filter"
                         let-filterService="filterService">
              <multicheck-filter [isPrimitive]="true"
                                 [field]="column.field"
                                 [filterService]="filterService"
                                 [currentFilter]="filter"
                                 [data]="distinctPrimitive(column.field)">
              </multicheck-filter>
            </ng-template>
          </kendo-grid-column>
          <kendo-grid-column field="Notas" title="Notas" width="150">
            <ng-template kendoGridFilterMenuTemplate
                         let-column="column"
                         let-filter="filter"
                         let-filterService="filterService">
              <multicheck-filter [isPrimitive]="true"
                                 [field]="column.field"
                                 [filterService]="filterService"
                                 [currentFilter]="filter"
                                 [data]="distinctPrimitive(column.field)">
              </multicheck-filter>
            </ng-template>
          </kendo-grid-column>
          <kendo-grid-column field="Cx" title="Cx" width="150">
            <ng-template kendoGridFilterMenuTemplate
                         let-column="column"
                         let-filter="filter"
                         let-filterService="filterService">
              <multicheck-filter [isPrimitive]="true"
                                 [field]="column.field"
                                 [filterService]="filterService"
                                 [currentFilter]="filter"
                                 [data]="distinctPrimitive(column.field)">
              </multicheck-filter>
            </ng-template>
          </kendo-grid-column>

        </ng-container>
        <ng-template kendoGridNoRecordsTemplate>
          {{ noRecords }}
        </ng-template>
      </kendo-grid>

    </div>
    <app-loading *ngIf="loading"></app-loading>
   

  </div>
</div>

<ng-template #modal let-c="close" let-d="dismiss" class="animated flipInX">
  <div class="modal-header">
    <div class="modal-title">
      <i class="fas fa-search"></i> {{ modalTitle }}
    </div>
    <button class="close" aria-label="Close" (click)="d()"><span aria-hidden="true">&times;</span></button>
  </div>
  <div class="modal-body">
    <div class="animated fadeIn">

      <app-buscar [typeSearch]="'H'" (resultFolio)="getDataModal($event, 'crt'); c();"
                  *ngIf="modalType == 'crt'"></app-buscar>
      <app-help-bandas (banda)="getDataModal($event, 'tbn'); c();" *ngIf="modalType == 'tbn'"></app-help-bandas>

      <div *ngIf="modalType == 'bgl'">
        <div class="row">
          <div class="col col-sm-10 col-md-10 col-lg-10 col-xl-10"></div>
          <div class="col col-sm-2 col-md-2 col-lg-2 col-xl-2">
            <button class="btn btn-block btn-success" (click)="buscarG()" [disabled]="!ngFormG.valid">
              <i class="fas fa-search mr-2"></i>Buscar
            </button>
          </div>
        </div>

        <div class="divider"></div>

        <form [formGroup]="ngFormG">
          <div class="row">
            <div class="col col-sm-4 col-md-4 col-lg-4 col-xl-4">
              <label>Tipo</label>
              <div class="input-group">
                <input type="text" class="form-control" maxlength="2" formControlName="cChr1">
                <div class="input-group-append">
                  <button class="btn btn-outline-secondary" type="button" (click)="openModalGlobal('tbnG')">
                    <i class="fas fa-search"></i>
                  </button>
                </div>
              </div>
            </div>
            <div class="col col-sm-4 col-md-4 col-lg-4 col-xl-4">
              <label>Desde</label>
              <input type="number" class="form-control" min="0" max="999999" formControlName="iInt1">
            </div>
            <div class="col col-sm-4 col-md-4 col-lg-4 col-xl-4">
              <label>Hasta</label>
              <input type="number" class="form-control" min="0" max="999999" formControlName="iInt2">
            </div>
          </div>
        </form>

        <div class="divider"></div>

        <div *ngIf="!loadingG">

          <kendo-grid [kendoGridBinding]="dataGridG"
                      [pageSize]="pageSize"
                      [sortable]="true"
                      filterable="menu"
                      [skip]="skip"
                      [pageable]="{buttonCount: 5, pageSizes: [10, 25, 50]}"
                      [height]="410">
            <ng-template kendoGridToolbarTemplate>
              <div class="row">
                <div class="col-sm-10 col-md-10 col-lg-10 col-xl-10"></div>
                <div class="col-sm-2 col-md-2 col-lg-2 col-xl-2">
                  <button class="btn btn-block btn-success" (click)="export(base64G)" [disabled]="base64G == ''">
                    <i class="fas fa-file-excel mr-2"></i>Excel
                  </button>
                </div>
              </div>
            </ng-template>
            <ng-container *ngIf="dataGridG.length !== 0">

              <kendo-grid-column field="Tipo" title="Tipo" width="150">
                <ng-template kendoGridFilterMenuTemplate
                             let-column="column"
                             let-filter="filter"
                             let-filterService="filterService">
                  <multicheck-filter [isPrimitive]="true"
                                     [field]="column.field"
                                     [filterService]="filterService"
                                     [currentFilter]="filter"
                                     [data]="distinctPrimitive(column.field)">
                  </multicheck-filter>
                </ng-template>
              </kendo-grid-column>
              <kendo-grid-column field="Brazalete" title="Banda" width="150">
                <ng-template kendoGridFilterMenuTemplate
                             let-column="column"
                             let-filter="filter"
                             let-filterService="filterService">
                  <multicheck-filter [isPrimitive]="true"
                                     [field]="column.field"
                                     [filterService]="filterService"
                                     [currentFilter]="filter"
                                     [data]="distinctPrimitive(column.field)">
                  </multicheck-filter>
                </ng-template>
              </kendo-grid-column>
              <kendo-grid-column field="Falta" title="Falta" width="80" [filterable]="false"></kendo-grid-column>

              <kendo-grid-column field="FechaEntrega" title="Fecha de Entrega" width="150">
                <ng-template kendoGridFilterMenuTemplate
                             let-filter let-column="column"
                             let-filterService="filterService">
                  <date-range-filter [field]="column.field"
                                     [filter]="filter"
                                     [filterService]="filterService">
                  </date-range-filter>
                </ng-template>
              </kendo-grid-column>
              <kendo-grid-column field="FechaVigencia" title="Fecha de Vigencia" width="150">
                <ng-template kendoGridFilterMenuTemplate
                             let-filter let-column="column"
                             let-filterService="filterService">
                  <date-range-filter [field]="column.field"
                                     [filter]="filter"
                                     [filterService]="filterService">
                  </date-range-filter>
                </ng-template>
              </kendo-grid-column>

              <kendo-grid-column field="NoCuarto" title="# Cuarto" width="150">
                <ng-template kendoGridFilterMenuTemplate
                             let-column="column"
                             let-filter="filter"
                             let-filterService="filterService">
                  <multicheck-filter [isPrimitive]="true"
                                     [field]="column.field"
                                     [filterService]="filterService"
                                     [currentFilter]="filter"
                                     [data]="distinctPrimitive(column.field)">
                  </multicheck-filter>
                </ng-template>
              </kendo-grid-column>
              <kendo-grid-column field="NoFolio" title="# Folio" width="150">
                <ng-template kendoGridFilterMenuTemplate
                             let-column="column"
                             let-filter="filter"
                             let-filterService="filterService">
                  <multicheck-filter [isPrimitive]="true"
                                     [field]="column.field"
                                     [filterService]="filterService"
                                     [currentFilter]="filter"
                                     [data]="distinctPrimitive(column.field)">
                  </multicheck-filter>
                </ng-template>
              </kendo-grid-column>
              <kendo-grid-column field="Notas" title="Notas" width="150">
                <ng-template kendoGridFilterMenuTemplate
                             let-column="column"
                             let-filter="filter"
                             let-filterService="filterService">
                  <multicheck-filter [isPrimitive]="true"
                                     [field]="column.field"
                                     [filterService]="filterService"
                                     [currentFilter]="filter"
                                     [data]="distinctPrimitive(column.field)">
                  </multicheck-filter>
                </ng-template>
              </kendo-grid-column>
              <kendo-grid-column field="Ope" title="Ope." width="150">
                <ng-template kendoGridFilterMenuTemplate
                             let-column="column"
                             let-filter="filter"
                             let-filterService="filterService">
                  <multicheck-filter [isPrimitive]="true"
                                     [field]="column.field"
                                     [filterService]="filterService"
                                     [currentFilter]="filter"
                                     [data]="distinctPrimitive(column.field)">
                  </multicheck-filter>
                </ng-template>
              </kendo-grid-column>
              <kendo-grid-column field="Cancelacion" title="Cancelación" width="150">
                <ng-template kendoGridFilterMenuTemplate
                             let-column="column"
                             let-filter="filter"
                             let-filterService="filterService">
                  <multicheck-filter [isPrimitive]="true"
                                     [field]="column.field"
                                     [filterService]="filterService"
                                     [currentFilter]="filter"
                                     [data]="distinctPrimitive(column.field)">
                  </multicheck-filter>
                </ng-template>
              </kendo-grid-column>

            </ng-container>
            <ng-template kendoGridNoRecordsTemplate>
              {{ noRecords }}
            </ng-template>
          </kendo-grid>

          <div class="divider"></div>

          <kendo-grid [data]="dataGridGlobal"
                      [height]="150">
            <ng-container *ngIf="dataGridGlobal.length !== 0">

              <kendo-grid-column field="Tipo" title="Tipo" width="150"></kendo-grid-column>
              <kendo-grid-column field="tTotal[0]" title="Asignadas" width="150"></kendo-grid-column>
              <kendo-grid-column field="tTotal[1]" title="Canceladas" width="150"></kendo-grid-column>
              <kendo-grid-column field="tTotal[2]" title="Faltantes" width="150"></kendo-grid-column>

            </ng-container>
            <ng-template kendoGridNoRecordsTemplate>
              {{ noRecords }}
            </ng-template>
          </kendo-grid>
        </div>
        <app-loading *ngIf="loadingG"></app-loading>
  
      </div>

      <app-help-bandas (banda)="getDataModalG($event, 'tbnG')" *ngIf="modalType == 'tbnG'"></app-help-bandas>

    </div>
  </div>
  <div class="modal-footer">
    <button class="btn btn-shadow btn-primary" (click)="c();">Cerrar</button>
  </div>
</ng-template>
